(*$B- Aufgabe 6.25 *)
PROGRAM spline;
USES Graph;   (*******)
TYPE vektor = ARRAY[1..20] OF real;
VAR n,i,fall,xh,yh, xg,yg,xt,yt,oldx,oldy, farbe,keine: integer;
    h, xi,yi, xmin,xmax,ymin,ymax: real;  x,y,ys: vektor;
    f : text; stri: string[20];

(*$I Alg6_4 Algorithmus 6.4: FUNCTION g *)
(*$I plotproz *)
(*$I alg6_5 Algorithmus 6.5: tridia *)
(*$I tridiazwei von Aufgabe 6.21 *)

PROCEDURE ableitungen(fall,n:integer; VAR x,y,ys:vektor);
VAR i:integer; fak: real; a,b,c,h,d,u,v:vektor;
BEGIN
   FOR i := 1 TO n-1 DO h[i]:=x[i+1]-x[i];
   FOR i := 1 TO n-1 DO d[i]:=(y[i+1]-y[i])/sqr(h[i]);
   FOR i := 2 TO n-1 DO
   BEGIN
       a[i] := 2/h[i-1]+2/h[i];  b[i]:=1/h[i];
       c[i]:=b[i]; ys[i] := 3*(d[i]+d[i-1]);
   END;
   CASE fall OF
     1:(*natuerlich*)
       BEGIN
         b[1]:=1/h[1]; c[1]:=b[1];a[1]:=2*b[1];
         a[n]:=2/h[n-1];
         ys[1]:=3*d[1]; ys[n]:=3*d[n-1];
         tridia(n,c,a,b,ys);
       END;
     2: (*de Boor*)
       BEGIN
         a[1]:=1/h[1]; c[1]:=a[1]; b[1]:=a[1]+1/h[2];
         a[n]:=1/h[n-1]; c[n-1]:=a[n]+1/h[n-2];
         ys[1]:=2*d[1]+(d[1]+d[2])/(h[1]+h[2])*h[1];
         ys[n]:=2*d[n-1]+(d[n-1]+d[n-2])/(h[n-1]+h[n-2])*h[n-1];
         tridia(n,c,a,b,ys);
       END;
     3:(*periodisch*)
       BEGIN
         b[1]:=1/h[1]; c[1]:=b[1];a[1]:=(2*b[1]+1/h[n-1]);
         a[n-1]:= 2/h[n-2]+1/h[n-1];
         FOR  i := 2 TO n-1 DO
         BEGIN u[i]:=0; v[i]:=3*(d[i]+d[i-1]) END;
         u[1]:=1; u[n-1]:=1; v[1]:=3*(d[1]+d[n-1]);
         tridiazwei(n-1,c,a,b,u,v);
         fak := (v[1]+v[n-1])/(u[1]+u[n-1]+h[n-1]);
         FOR i:= 1 TO n-1 DO ys[i]:=v[i]-fak*u[i];
         ys[n]:=ys[1];
       END;
   END;

END;

PROCEDURE ini;
BEGIN
   writeln('Inputfilenamen ?'); readln(stri);
   assign(f, stri); reset(f);
   writeln('Punkte x,y eingeben. Die x in aufsteigender Reihenfolge. ');
   writeln('Nach letztem y mit ctrl-z abbrechen');
   n:=0;
   WHILE  NOT eof(f)DO
   BEGIN
      n := n+1; writeln('x,y?'); read(f,x[n],y[n])
   END;
   FOR i := 1 TO n DO writeln(x[i],y[i]);
END;

PROCEDURE menue;
BEGIN
  REPEAT
    writeln('Fall fuer Ableitungen :');
    writeln('1:Natuerliche Randbedingungen');
    writeln('2:Not a knot condition von de Boor');
    writeln('3:Periodischer Spline');
    readln(fall)
  UNTIL fall IN [1..3]
END;

BEGIN
   ini; reset(input); menue;
   ableitungen(fall,n,x,y,ys);
   writeln('Ableitungen');
   FOR i := 1 TO n DO writeln(ys[i]);
   writeln('Neustelle eingeben, mit CTRL-Z aufhoeren');
   REPEAT
      write('x = '); read(xi); yi := g(n,xi,x,y,ys);
      writeln('  g(x) = ',yi);
   UNTIL eof; reset(input);
   writeln('xmin,xmax,ymin,ymax eingeben');
   readln(xmin,xmax,ymin,ymax);
   plotbegin( xg,yg,xt,yt,farbe,keine);
   achsen(xmin,xmax,ymin,ymax,xg,yg,xt,yt,farbe, keine);
   for i := 1 to n do kreuz(x[i],y[i],5);
   { gotoxy(1,24); } (*********)

   pl(xmin,g(n,xmin,x,y,ys),keine);
   h := (xmax-xmin)/xg;
   FOR  i := 0 TO xg DO
   BEGIN
      xi := xmin +i*h;  pl(xi,g(n,xi,x,y,ys),farbe)
   END;
   readln
END.




