(*$B- Testprogramm fuer die Algorithmen 5.3 und 5.4 Aufloesung
      eines linearen Gleichungssystems OHNE Pivotsuche*)
PROGRAM lingl;
CONST nn=20;
TYPE vektor = ARRAY[1..nn] OF real;
     matrix = ARRAY[1..nn] OF vektor;
VAR a: matrix; b,x : vektor;
    i,n : integer;

(*$I rueckwae  (Algorithmus 5.3) *)

PROCEDURE druck(a:matrix; b:vektor; s:integer);
VAR i,j,m : integer;
BEGIN
   FOR i := 1 TO n DO
   BEGIN
     IF i<s THEN m:=i-1 ELSE m:=s-1;
     FOR j:= 1 TO m DO write('          ');
     FOR j:= m+1 TO n DO write(a[i,j]:10);
     write('     ');
     writeln(b[i]:10);
   END;
   writeln;writeln;
END;

PROCEDURE lies(VAR a:matrix; VAR b:vektor);
VAR i,j : integer;
BEGIN
   writeln('Gleichungen zeilenweise eingeben');
   FOR i := 1 TO n DO
   BEGIN
     FOR j := 1 TO n DO read(a[i,j]);
     read(b[i]);
   END;
END;


(* Algorithmus 5.4 *)
PROCEDURE elimination;
VAR faktor: real; i,j,k:integer;
BEGIN
  FOR i := 1 TO n-1 DO
  FOR k := i+1 TO n DO
  BEGIN
    faktor:=a[k,i]/a[i,i];
    FOR j:= i+1 TO n DO
      a[k,j]:= a[k,j]-faktor*a[i,j];
    b[k]:=b[k]-faktor*b[i]
  END
END;


BEGIN
  writeln('WIEVIELE UNBEKANNTE?'); read(n);
  lies(a,b);
  elimination;
  rueckwaertseinsetzen(n,a,b,x);
  FOR i:= 1 TO n DO writeln(x[i]);
END.
