(*$B- Aufgabe 5.10A *)
PROGRAM qr ;
CONST nn=20;
TYPE vektor = ARRAY[1..nn] OF real;
     matrix = ARRAY[1..nn] OF vektor;
VAR qt,a: matrix;  i,j,k,n:integer; s:real;

PROCEDURE eingabe(VAR a:matrix);
VAR i,j : integer;
BEGIN
  writeln('Matrix A zeilenweise eingeben');
  FOR i:=1 TO n DO
  BEGIN
    writeln('Zeile Nr.',i:3);
    FOR j:=1 TO n DO read(a[i,j])
  END
END;

PROCEDURE givenselimination;
(* Die Givensmatrizen werden zusammenmultipliziert und ergeben Q^T *)
VAR i,j,k: integer; cot,co,si,h: real;
BEGIN
 (*Initialisierung von Q^T = I *)
 FOR i:= 1 TO n DO FOR j := 1 TO n DO
 IF i=j THEN qt[i,i]:=1 ELSE qt[i,j] :=0;

 FOR i:= 1 TO n DO
 BEGIN
  FOR k := i+1 TO n DO
   IF a[k,i]<>0 THEN
   BEGIN
     cot:=a[i,i]/a[k,i];
     si:=1/sqrt(1+cot*cot); co:=si*cot;
     a[i,i]:=a[i,i]*co+a[k,i]*si;
     FOR j:=i+1 TO n DO
     BEGIN
       h:=a[i,j]*co+a[k,j]*si;
       a[k,j]:=-a[i,j]*si+a[k,j]*co;
       a[i,j]:=h
     END;
     (* Q^T := G*Q^T *)
     FOR j:=1 TO n DO
     BEGIN
       h:=qt[i,j]*co+qt[k,j]*si;
       qt[k,j]:=-qt[i,j]*si+qt[k,j]*co;
       qt[i,j]:=h
     END
   END
  END
END;

PROCEDURE kontrolle;
BEGIN
  FOR i := 2 TO n DO
  FOR j := 1 TO i-1 DO a[i,j]:=0;
  writeln('Kontrolle Q*R=');
  FOR i := 1 TO n DO
  BEGIN
     FOR j := 1 TO n DO
     BEGIN
        s := 0;
        FOR k := 1 TO n DO s := s + qt[k,i]*a[k,j];
        write(s:10:5);
     END;
     writeln;
  END;
  writeln('Q^T*Q =');
  FOR i := 1 TO n DO
  BEGIN
     FOR j := 1 TO n DO
     BEGIN
        s := 0;
        FOR k := 1 TO n DO s := s + qt[i,k]*qt[j,k];
        write(s:10:5);
     END;
     writeln;
  END
END;

BEGIN
 writeln('Ordnung der Matrix'); read(n);
 eingabe(a);
 givenselimination;
 writeln('Matrix R');
 FOR i := 1 TO n DO
 BEGIN
    FOR j := 1 TO i-1 DO write(' ':10);
    FOR j := i TO n DO write(a[i,j]:10:5);
    writeln
 END;
 writeln('Matrix Q');
 FOR i := 1 TO n DO
 BEGIN
    FOR j := 1 TO n DO write(qt[j,i]:10:5);
    writeln
 END;
 kontrolle;
END.
